/*
    Project: TCTEMP
    Version: V1.5
    File   : na_file.c

    Copyright (c) 2006-2007 Author of TCTEMP. All rights reserved.
    Public Key Fingerprint: 75EB 6BC2 01B7 F6E7 4BD7 CC58 4A5F C393 19EE 6E69

    Covered by TrueCrypt License 2.2 the full text of which is contained
    in the file License.txt included in TCTEMP binary and source code
    distribution archives.

    The copyright notice of this source code file and the public key
    fingerprint must be retained in full.
*/

#include "na_priv.h"

BOOL NAAPI NaCreateFile(PHANDLE phFile, PCWSTR pcwszFileName,
  ACCESS_MASK amDesiredAccess, ULONG ulFileAttributes, ULONG ulShareAccess,
  ULONG ulCreateDisposition, ULONG ulCreateOptions)
{
    NTSTATUS          ntStatus;
    UNICODE_STRING    usObjectName;
    OBJECT_ATTRIBUTES oa;
    IO_STATUS_BLOCK   isb;

    NaAssert(phFile);
    NaAssert(pcwszFileName);

    RtlInitUnicodeString(&usObjectName, pcwszFileName);
    InitializeObjectAttributes(&oa, &usObjectName,
      OBJ_CASE_INSENSITIVE, NULL, NULL);
    ntStatus = NtCreateFile(phFile, amDesiredAccess | SYNCHRONIZE, &oa,
      &isb, NULL, ulFileAttributes, ulShareAccess, ulCreateDisposition,
      ulCreateOptions, NULL, 0);
    if (!NT_SUCCESS(ntStatus)) {
        NaDbgPrintf(L"Cannot create/open file \"%s\" (0x%08x)", pcwszFileName,
          ntStatus);
        return FALSE;
    }

    return TRUE;
}
