/*
    Project: TCTEMP
    Version: V1.5
    File   : na_sleep.c

    Copyright (c) 2006-2007 Author of TCTEMP. All rights reserved.
    Public Key Fingerprint: 75EB 6BC2 01B7 F6E7 4BD7 CC58 4A5F C393 19EE 6E69

    Covered by TrueCrypt License 2.2 the full text of which is contained
    in the file License.txt included in TCTEMP binary and source code
    distribution archives.

    The copyright notice of this source code file and the public key
    fingerprint must be retained in full.
*/

#include "na_priv.h"

void NAAPI NaSleep(DWORD dwTime)
{
    OBJECT_ATTRIBUTES oa;
    HANDLE            hEvent;

    InitializeObjectAttributes(&oa, NULL, 0, NULL, NULL);
    if (NT_SUCCESS(NtCreateEvent(&hEvent, EVENT_ALL_ACCESS, &oa,
      SynchronizationEvent, FALSE))) {
        LARGE_INTEGER liTimeout;
        liTimeout.QuadPart = NA_TIMEOUT(dwTime);
        NtWaitForSingleObject(hEvent, FALSE, &liTimeout);
        NtClose(hEvent);
    }
}
